# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr
from edgeimpulse_api.models.ai_actions_config_step import AIActionsConfigStep
from edgeimpulse_api.models.ai_actions_data_category import AIActionsDataCategory

class AIActionsConfig(BaseModel):
    data_category: AIActionsDataCategory = Field(..., alias="dataCategory")
    data_metadata_key: Optional[StrictStr] = Field(None, alias="dataMetadataKey", description="Metadata key to filter on. Required if dataCategory is equal to \"dataWithoutMetadataKey\" or \"dataWithMetadata\".")
    data_metadata_value: Optional[StrictStr] = Field(None, alias="dataMetadataValue", description="Metadata value to filter on. Required if dataCategory is equal to \"dataWithMetadata\".")
    steps: List[AIActionsConfigStep] = ...
    __properties = ["dataCategory", "dataMetadataKey", "dataMetadataValue", "steps"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self,indent=None) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict(),indent=indent)

    @classmethod
    def from_json(cls, json_str: str) -> AIActionsConfig:
        """Create an instance of AIActionsConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in steps (list)
        _items = []
        if self.steps:
            for _item in self.steps:
                if _item:
                    _items.append(_item.to_dict())
            _dict['steps'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AIActionsConfig:
        """Create an instance of AIActionsConfig from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return AIActionsConfig.construct(**obj)

        _obj = AIActionsConfig.construct(**{
            "data_category": obj.get("dataCategory"),
            "data_metadata_key": obj.get("dataMetadataKey"),
            "data_metadata_value": obj.get("dataMetadataValue"),
            "steps": [AIActionsConfigStep.from_dict(_item) for _item in obj.get("steps")] if obj.get("steps") is not None else None
        })
        return _obj

