# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field

class ClassifySampleResponseClassificationDetails(BaseModel):
    boxes: Optional[List[List[float]]] = Field(None, description="Bounding boxes predicted by localization model")
    labels: Optional[List[float]] = Field(None, description="Labels predicted by localization model")
    scores: Optional[List[float]] = Field(None, description="Scores predicted by localization model")
    m_ap: Optional[float] = Field(None, alias="mAP", description="For object detection, the COCO mAP computed for the predictions on this image")
    f1: Optional[float] = Field(None, description="For FOMO, the F1 score computed for the predictions on this image")
    __properties = ["boxes", "labels", "scores", "mAP", "f1"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self,indent=None) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict(),indent=indent)

    @classmethod
    def from_json(cls, json_str: str) -> ClassifySampleResponseClassificationDetails:
        """Create an instance of ClassifySampleResponseClassificationDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ClassifySampleResponseClassificationDetails:
        """Create an instance of ClassifySampleResponseClassificationDetails from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return ClassifySampleResponseClassificationDetails.construct(**obj)

        _obj = ClassifySampleResponseClassificationDetails.construct(**{
            "boxes": obj.get("boxes"),
            "labels": obj.get("labels"),
            "scores": obj.get("scores"),
            "m_ap": obj.get("mAP"),
            "f1": obj.get("f1")
        })
        return _obj

