# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, validator

class CreateUserThirdPartyResponse(BaseModel):
    success: StrictBool = Field(..., description="Whether the operation succeeded")
    error: Optional[StrictStr] = Field(None, description="Optional error description (set if 'success' was false)")
    status: StrictStr = ...
    jwt_token: Optional[StrictStr] = Field(None, alias="jwtToken")
    __properties = ["success", "error", "status", "jwtToken"]

    @validator('status')
    def status_validate_enum(cls, v):
        if v not in ('userWasCreated', 'userNotManagedByThirdParty', 'userAlreadyExists'):
            raise ValueError("must validate the enum values ('userWasCreated', 'userNotManagedByThirdParty', 'userAlreadyExists')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self,indent=None) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict(),indent=indent)

    @classmethod
    def from_json(cls, json_str: str) -> CreateUserThirdPartyResponse:
        """Create an instance of CreateUserThirdPartyResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateUserThirdPartyResponse:
        """Create an instance of CreateUserThirdPartyResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CreateUserThirdPartyResponse.construct(**obj)

        _obj = CreateUserThirdPartyResponse.construct(**{
            "success": obj.get("success"),
            "error": obj.get("error"),
            "status": obj.get("status"),
            "jwt_token": obj.get("jwtToken")
        })
        return _obj

