# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from edgeimpulse_api.models.auto_labeler_segment import AutoLabelerSegment
from edgeimpulse_api.models.sample import Sample

class GetAutoLabelerSegmentInfoResponse(BaseModel):
    success: StrictBool = Field(..., description="Whether the operation succeeded")
    error: Optional[StrictStr] = Field(None, description="Optional error description (set if 'success' was false)")
    sample: Sample = ...
    image_url: StrictStr = Field(..., alias="imageUrl")
    segments: List[AutoLabelerSegment] = ...
    __properties = ["success", "error", "sample", "imageUrl", "segments"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self,indent=None) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict(),indent=indent)

    @classmethod
    def from_json(cls, json_str: str) -> GetAutoLabelerSegmentInfoResponse:
        """Create an instance of GetAutoLabelerSegmentInfoResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of sample
        if self.sample:
            _dict['sample'] = self.sample.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in segments (list)
        _items = []
        if self.segments:
            for _item in self.segments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['segments'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetAutoLabelerSegmentInfoResponse:
        """Create an instance of GetAutoLabelerSegmentInfoResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return GetAutoLabelerSegmentInfoResponse.construct(**obj)

        _obj = GetAutoLabelerSegmentInfoResponse.construct(**{
            "success": obj.get("success"),
            "error": obj.get("error"),
            "sample": Sample.from_dict(obj.get("sample")) if obj.get("sample") is not None else None,
            "image_url": obj.get("imageUrl"),
            "segments": [AutoLabelerSegment.from_dict(_item) for _item in obj.get("segments")] if obj.get("segments") is not None else None
        })
        return _obj

