# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from edgeimpulse_api.models.resource_range import ResourceRange
from edgeimpulse_api.models.target_memory import TargetMemory

class TargetProcessor(BaseModel):
    part: Optional[StrictStr] = Field(None, description="The exact part number, if available")
    format: Optional[StrictStr] = Field(None, description="Processor type, serving as a broad descriptor for the intended use-case")
    architecture: Optional[StrictStr] = Field(None, description="Processor family, informing about the processor's instruction set and core design")
    specific_architecture: Optional[StrictStr] = Field(None, alias="specificArchitecture", description="Processor architecture, informing about the specific processor, if known")
    accelerator: Optional[StrictStr] = Field(None, description="Target accelerator, if any")
    fpu: Optional[StrictBool] = Field(None, description="Does the target processor have a floating point unit")
    clock_rate_mhz: Optional[ResourceRange] = Field(None, alias="clockRateMhz")
    memory: Optional[TargetMemory] = None
    __properties = ["part", "format", "architecture", "specificArchitecture", "accelerator", "fpu", "clockRateMhz", "memory"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self,indent=None) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict(),indent=indent)

    @classmethod
    def from_json(cls, json_str: str) -> TargetProcessor:
        """Create an instance of TargetProcessor from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of clock_rate_mhz
        if self.clock_rate_mhz:
            _dict['clockRateMhz'] = self.clock_rate_mhz.to_dict()
        # override the default output from pydantic by calling `to_dict()` of memory
        if self.memory:
            _dict['memory'] = self.memory.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TargetProcessor:
        """Create an instance of TargetProcessor from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return TargetProcessor.construct(**obj)

        _obj = TargetProcessor.construct(**{
            "part": obj.get("part"),
            "format": obj.get("format"),
            "architecture": obj.get("architecture"),
            "specific_architecture": obj.get("specificArchitecture"),
            "accelerator": obj.get("accelerator"),
            "fpu": obj.get("fpu"),
            "clock_rate_mhz": ResourceRange.from_dict(obj.get("clockRateMhz")) if obj.get("clockRateMhz") is not None else None,
            "memory": TargetMemory.from_dict(obj.get("memory")) if obj.get("memory") is not None else None
        })
        return _obj

