# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class VerifyOrganizationBucketRequest(BaseModel):
    access_key: StrictStr = Field(..., alias="accessKey", description="S3 access key")
    secret_key: StrictStr = Field(..., alias="secretKey", description="S3 secret key")
    bucket: StrictStr = Field(..., description="S3 bucket")
    endpoint: StrictStr = Field(..., description="S3 endpoint")
    region: StrictStr = Field(..., description="S3 region")
    prefix: Optional[StrictStr] = Field(None, description="Optional prefix in the bucket. Set this if you don't have access to the full bucket for example.")
    __properties = ["accessKey", "secretKey", "bucket", "endpoint", "region", "prefix"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self,indent=None) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict(),indent=indent)

    @classmethod
    def from_json(cls, json_str: str) -> VerifyOrganizationBucketRequest:
        """Create an instance of VerifyOrganizationBucketRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> VerifyOrganizationBucketRequest:
        """Create an instance of VerifyOrganizationBucketRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return VerifyOrganizationBucketRequest.construct(**obj)

        _obj = VerifyOrganizationBucketRequest.construct(**{
            "access_key": obj.get("accessKey"),
            "secret_key": obj.get("secretKey"),
            "bucket": obj.get("bucket"),
            "endpoint": obj.get("endpoint"),
            "region": obj.get("region"),
            "prefix": obj.get("prefix")
        })
        return _obj

